use std::fs;

const BLANK:char = '.';

const FILE_NAME:&str = "./data/data.txt";
fn main() {
    let file_contents = fs::read_to_string(FILE_NAME).unwrap();
    let lines:Vec<&str> = file_contents.split('\n').collect();
    let mut final_output = 0_usize;
    let mut map:Vec<Vec<char>> = Vec::new();
    for line in lines{
        let line_string = line.trim().to_string();
        map.push(line_string.chars().collect());
    }
    for i in 0..(map.len()){
        let mut place = 0;
        let mut next_number = 0usize;
        let mut continue_adding = false;
        let mut back_index = 0;
        let line = map.get(i).unwrap();
        for j in (0..(line.len())).rev(){
            let current_char = *line.get(j).unwrap();
            if let Some(digit) = current_char.to_digit(10){
                if is_back(line.clone(), j){
                    next_number += digit as usize * 10_usize.pow(place);
                    place += 1;
                    continue_adding = true;
                    back_index = j;
                } else if continue_adding{
                    next_number += digit as usize * 10_usize.pow(place);
                    place += 1;
                };
                if is_front(line.clone(),j){
                    print!("{:?}\t",next_number);
                    if is_a_part_number(map.clone(),back_index,j,i){
                        final_output += next_number;
                    } 
                    println!("{:?},{:?}",i,j);
                    next_number = 0;
                    place = 0;
                    continue_adding = false;
                }
            };
        };
    };
    println!("{}",final_output);
}

fn is_a_part_number(map:Vec<Vec<char>>,back_index:usize,front_index:usize,row:usize) -> bool{
    let mut return_value = false;
    if front_index > 0{
        return_value |= is_special_char(*map.get(row).unwrap().get(front_index - 1).unwrap());
    }
    return_value |= check_above(map.clone(), front_index, back_index, row);
    return_value |= check_below(map.clone(), front_index, back_index, row);
    if let Some(back_check) = map.get(row).unwrap().get(back_index + 1){
        return_value |= is_special_char(*back_check);
    }
    return_value
}

fn is_back(line:Vec<char>,index:usize) -> bool{
    line.get(index + 1).is_some_and(|x| !x.is_digit(10)) || line.get(index + 1).is_none()
}

fn is_front(line:Vec<char>,index:usize) -> bool{
    if index == 0 {
        true
    } else { line.get(index - 1).is_some_and(|x| !x.is_digit(10)) }
}

fn is_special_char(char:char) -> bool{
    let return_val = !char.is_alphabetic() && !char.is_digit(10) && char != BLANK;
    if return_val{ print!("{:?}",char); };
    return return_val;
}

fn check_above(map:Vec<Vec<char>>,front_index:usize,back_index:usize, current_row:usize) -> bool{
    if current_row == 0 { return false; }
    let line = map.get(current_row - 1).unwrap();
    let min_val:usize;
    if front_index == 0{
        min_val = 0;
    } else {
        min_val = front_index - 1;
    }
    for i in min_val..=(back_index+1){
        if line.get(i).is_some_and(|x| is_special_char(*x)){
            return true;
        }
    }
    false
}

fn check_below(map:Vec<Vec<char>>,front_index:usize,back_index:usize, current_row:usize) -> bool{
    if let Some(line) = map.get(current_row + 1){
        let min_val:usize;
        if front_index == 0{
            min_val = 0;
        } else {
            min_val = front_index - 1;
        }
        for i in min_val..=(back_index+1){
            if line.get(i).is_some_and(|x| is_special_char(*x)){
                return true;
            }
        }
    }
    false
}
